(* Title:  "Minisubpbl/300-init-subpbl.sml"
   Author: Walther Neuper 1105
   (c) copyright due to lincense terms.
*)
open LI;
open LItool;
open Step;
open Istate;

"----------- Minisubpbl/300-init-subpbl.sml ----------------------";
"----------- Minisubpbl/300-init-subpbl.sml ----------------------";
"----------- Minisubpbl/300-init-subpbl.sml ----------------------";
val fmz = ["equality (x+1=(2::real))", "solveFor x", "solutions L"];
val (dI',pI',mI') =
  ("Test", ["sqroot-test", "univariate", "equation", "test"],
   ["Test", "squ-equ-test-subpbl1"]);
(*[], Pbl*)val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))];
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt;
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt;
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt;
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt;
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt;
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt;
(*[], Met*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; val Apply_Method ["Test", "squ-equ-test-subpbl1"] = nxt;
(*[1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; val Rewrite_Set "norm_equation" = nxt;
(*[1], Res*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; val Rewrite_Set "Test_simplify" = nxt;
                                                   
(*[2], Res*)val return_Rewrite_Set_Test_simplify = me nxt p [] pt;
(*/------------------- step into me_Rewrite_Set_Test_simplify ------------------------------\\*)
"~~~~~ fun me , args:"; val (tac, p, _(*NEW remove*), pt) = (nxt, p, [], pt);
      val ctxt = Ctree.get_ctxt pt p
val ("ok", (_, _, ptp as (pt, p))) =
  	    (*case*) Step.by_tactic tac (pt, p) (*of*);

        (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
(*//------------------ step into do_next ---------------------------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) =
  (p, ((pt, Pos.e_pos'), []));
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

           switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*else*);

        LI.do_next (pt, input_pos);
"~~~~~ and do_next , args:"; val (ptp as (pt, pos as (p, p_))) = (pt, input_pos);
    (*if*) MethodC.id_empty = get_obj g_metID pt (par_pblobj pt p) (*else*);
	      val ((ist, ctxt), sc) = LItool.resume_prog (p,p_) pt;

        (*case*)
        LI.find_next_step sc (pt, pos) ist ctxt (*of*);
"~~~~~ fun find_next_step , args:"; val ((Rule.Prog prog), (ptp as (pt, pos as (p, _))), (Pstate ist), ctxt) =
  (sc, (pt, pos), ist, ctxt);
  (*case*) scan_to_tactic (prog, (ptp, ctxt)) (Pstate ist) (*of*);
"~~~~~ fun scan_to_tactic , args:"; val ((prog, cc), (Pstate (ist as {path, ...}))) =
  ((prog, (ptp, ctxt)), (Pstate ist));
  (*if*) path = [] (*else*);

           go_scan_up (prog, cc) (trans_scan_up ist);
"~~~~~ fun go_scan_up , args:"; val ((pcc as (sc, _)), (ist as {path, act_arg, found_accept, ...})) =
  ((prog, cc), (trans_scan_up ist));
    (*if*) path = [R] (*root of the program body*) (*else*);

           scan_up pcc (ist |> path_up) (go_up ctxt path sc);
"~~~~~ and scan_up , args:"; val (pcc, ist, (Const (\<^const_name>\<open>Tactical.Try\<close>(*2*), _) $ _)) =
  (pcc, (ist |> path_up), (go_up ctxt path sc));

           go_scan_up pcc ist;
"~~~~~ fun go_scan_up , args:"; val ((pcc as (sc, _)), (ist as {path, act_arg, found_accept, ...})) =
  (pcc, ist);
    (*if*) path = [R] (*root of the program body*) (*else*);

           scan_up pcc (ist |> path_up) (go_up ctxt path sc);
"~~~~~ and scan_up , args:"; val (pcc, ist, (Const (\<^const_name>\<open>Tactical.Chain\<close>(*2*), _) $ _ $ _)) =
  (pcc, (ist |> path_up), (go_up ctxt path sc));

           go_scan_up pcc ist;
"~~~~~ fun go_scan_up , args:"; val ((pcc as (sc, _)), (ist as {path, act_arg, found_accept, ...})) =
  (pcc, ist);
    (*if*) path = [R] (*root of the program body*) (*else*);

           scan_up pcc (ist |> path_up) (go_up ctxt path sc);
"~~~~~ and scan_up , args:"; val (pcc, ist, (Const (\<^const_name>\<open>Tactical.Chain\<close>(*1*), _) $ _ $ _ $ _)) =
  (pcc, (ist |> path_up), (go_up ctxt path sc));

           go_scan_up pcc ist;
"~~~~~ fun go_scan_up , args:"; val ((pcc as (sc, _)), (ist as {path, act_arg, found_accept, ...})) =
  (pcc, ist);
    (*if*) path = [R] (*root of the program body*) (*else*);

           scan_up pcc (ist |> path_up) (go_up ctxt path sc);
"~~~~~ and scan_up , args:"; val (pcc as (sc, cc as (_, ctxt)), ist, (Const (\<^const_name>\<open>Let\<close>(*1*), _) $ _)) =
  (pcc, (ist |> path_up), (go_up ctxt path sc));
        val (i, body) = check_Let_up ctxt ist sc;

        (*case*) scan_dn cc (ist |> path_up_down [R, D] |> upd_env i) body (*of*);
"~~~~~ fun scan_dn , args:"; val (cc, ist, (Const (\<^const_name>\<open>Let\<close>(*1*), _) $ e $ (Abs (i, T, b)))) =
  (cc, (ist |> path_up_down [R, D] |> upd_env i), body);

  (*case*) scan_dn cc (ist |> path_down [L, R]) e (*of*);
"~~~~~ fun scan_dn , args:"; val ((cc as (_, ctxt)), (ist as {eval, ...}), t (*fall-through*)) =
  (cc, (ist |> path_down [L, R]), e);
(*+*)val "SubProblem\n (''Test'', [''LINEAR'', ''univariate'', ''equation'', ''test''],\n  [''Test'', ''solve_linear''])\n [BOOL e_e, REAL v_v]" =
(*+*)  UnparseC.term @{context} e;
    (*if*) Tactical.contained_in t (*else*);
val (Program.Tac prog_tac, form_arg) =
      (*case*) LItool.check_leaf "next  " ctxt eval (get_subst ist) t (*of*);

           check_tac cc ist (prog_tac, form_arg);
"~~~~~ fun check_tac , args:"; val (((pt, p), ctxt), ist, (prog_tac, form_arg)) =
  (cc, ist, (prog_tac, form_arg));

    val m =
    LItool.tac_from_prog (pt, p) prog_tac;
"~~~~~ fun tac_from_prog , args:"; val ((pt, p), _, (ptac as Const (\<^const_name>\<open>Prog_Tac.SubProblem\<close>, _) $ _ $ _)) =
  ((pt, p), (Proof_Context.theory_of ctxt), prog_tac);

    fst
(Sub_Problem.tac_from_prog (pt, p) ptac);
"~~~~~ fun tac_from_prog , args:"; val ((pt, p), (stac as Const (\<^const_name>\<open>Prog_Tac.SubProblem\<close>, _) $ spec' $ ags')) =
  ((pt, p), ptac);
      val (dI, pI, mI) = Prog_Tac.dest_spec spec'
      val thy = Sub_Problem.common_sub_thy (Know_Store.get_via_last_thy dI, Ctree.root_thy pt);
      val init_ctxt = Proof_Context.init_global thy
	    val ags = TermC.isalist2list ags';
	    val (pI, pors, mI) = 
	      if mI = ["no_met"]
	      then
          let
            val pors = (M_Match.arguments thy ((#model o (Problem.from_store init_ctxt)) pI) ags): O_Model.T
		          handle ERROR "actual args do not match formal args"
			          => (M_Match.arguments_msg init_ctxt pI stac ags (*raise exn*);[]);
		        val pI' = Refine.by_o_model' init_ctxt pors pI;
		      in (pI', pors (* refinement over models with diff.prec only *), 
		          (hd o #solve_mets o Problem.from_store init_ctxt) pI') end
	      else (pI, (M_Match.arguments thy ((#model o Problem.from_store init_ctxt) pI) ags)
		      handle ERROR "actual args do not match formal args"
		      => (M_Match.arguments_msg init_ctxt pI stac ags(*raise exn*); []), mI);
      val (fmz_, vals) = O_Model.values' init_ctxt pors;
	    val {cas, model, thy, ...} = Problem.from_store init_ctxt pI
	    val dI = Context.theory_name thy (*take dI from _refined_ pbl*)
	    val dI = Context.theory_name
        (Sub_Problem.common_sub_thy (Know_Store.get_via_last_thy dI, Ctree.root_thy pt))
	    val ctxt = ContextC.init_for_prog init_ctxt vals
(*-------------------- stop step into do_next ------------------------------------------------*)
(*\\------------------ step into do_next ---------------------------------------------------//*)
(*\------------------- step into me_Rewrite_Set_Test_simplify ------------------------------//*)
(*[2], Res*)val (p,_,f,nxt,_,pt) = return_Rewrite_Set_Test_simplify;
                                                    val Subproblem ("Test", ["LINEAR", "univariate", "equation", "test"]) = nxt;
(*[3], Pbl*)val return_me_Model_Problem_sub = me nxt p [] pt;
(*/------------------- step into me_Model_Problem_sub -------------------------------------\\*)
"~~~~~ fun me , args:"; val (tac, p, _(*NEW remove*), pt) = (nxt, p, [], pt);

(*ERROR: Specify_Step.check Model_Problem: uncovered case Ctree.get_obj*)
    val ("ok", (_, _, (pt'''', p''''))) = (*case*)
      Step.by_tactic tac (pt, p) (*of*);
(*//------------------ step into by_tactic Subproblem --------------------------------------\\*)
(*+*)get_ctxt pt'''' p'''' |> ContextC.is_empty; (*should NOT be true after this step*)

"~~~~~ fun by_tactic , args:"; val (tac, ptp as (pt, p)) = (tac, (pt, p));
  val Applicable.Yes m = Step.check tac (pt, p);
  (*if*) Tactic.for_specify' m; (*false*)

(*val (msg, cs') =*)
Step_Solve.by_tactic m (pt, p);
"~~~~~ fun by_tactic , args:"; val (m, (pt, po as (p,p_))) = (m, (pt, p));
  (*if*) MethodC.id_empty = get_obj g_metID pt (par_pblobj pt p) (*false*);
	      val thy' = get_obj g_domID pt (par_pblobj pt p);
	      val (is, sc) = resume_prog (p,p_) pt;

val Safe_Step (Pstate ist''''', ctxt''''', tac'_''''') =
           locate_input_tactic sc (pt, po) (fst is) (snd is) m;
"~~~~~ fun locate_input_tactic , args:"; val (Rule.Prog prog, cstate, istate, ctxt, tac)
     = (sc, (pt, po), (fst is), (snd is), m);

(** )val Accept_Tac1 (_, _, Subproblem' (_, _, _, _, _, _)) = ( *case*)
           scan_to_tactic1 (prog, (cstate, ctxt, tac)) istate (*of*);
"~~~~~ fun scan_to_tactic1 , args:"; val ((prog, (cctt as ((_, p), _, _))), (Pstate (ist as {path, ...})))
  = ((prog, (cstate, ctxt, tac)), istate);
   (*if*) path = [] orelse ((last_elem o fst) p = 0 andalso snd p = Res) (*else*);

           go_scan_up1 (prog, cctt) ist;
"~~~~~ fun go_scan_up1 , args:"; val ((pcct as (prog, _)), (ist as {path, act_arg, ...}))
  = ((prog, cctt), ist);
   (*if*) 1 < length path (*true*);

           scan_up1 pcct (ist |> path_up) (TermC.sub_at (path_up' path) prog);
"~~~~~ and scan_up1 , args:"; val (pcct, ist, (Const (\<^const_name>\<open>Try\<close>(*2*), _) $ _))
  = (pcct, (ist |> path_up), (TermC.sub_at (path_up' path) prog));

           go_scan_up1 pcct ist;
"~~~~~ fun go_scan_up1 , args:"; val ((pcct as (prog, _)), (ist as {path, ...}))
  = (pcct, ist);
   (*if*) 1 < length path (*true*);

           scan_up1 pcct (ist |> path_up) (TermC.sub_at (path_up' path) prog);
"~~~~~ and scan_up1 , args:"; val (pcct, ist, (Const (\<^const_name>\<open>Chain\<close>(*2*), _) $ _ $ _))
  = (pcct, (ist |> path_up), (TermC.sub_at (path_up' path) prog));

           go_scan_up1 pcct ist (*2*: comes from e2*);
"~~~~~ fun go_scan_up1, args:"; val ((pcct as (prog, _)), (ist as {path, ...}))
  = (pcct, ist);
   (*if*) 1 < length path (*true*);

           scan_up1 pcct (ist |> path_up) (TermC.sub_at (path_up' path) prog);
"~~~~~ and scan_up1 , args:"; val (pcct, ist, (Const (\<^const_name>\<open>Chain\<close>(*1*), _) $ _ $ _ $ _))
  = (pcct, (ist |> path_up), (TermC.sub_at (path_up' path) prog));

       go_scan_up1 pcct ist (*all has been done in (*2*) below*);
"~~~~~ fun go_scan_up1, args:"; val ((pcct as (prog, _)), (ist as {path, ...}))
  = (pcct, ist);
   (*if*) 1 < length path (*true*);

           scan_up1 pcct (ist |> path_up) (TermC.sub_at (path_up' path) prog);
"~~~~~ and scan_up1 , args:"; val ((pcct as (prog, cct as (cstate, ctxt, _))), ist, (Const (\<^const_name>\<open>Let\<close>(*1*), _) $ _))
  = (pcct, (ist |> path_up), (TermC.sub_at (path_up' path) prog));
      val (i, body) = check_Let_up ctxt ist prog;

  (*case*) scan_dn1 cct (ist |> path_up_down [R, D] |> upd_env i |> set_or ORundef) body (*of*);
"~~~~~ fun scan_dn1 , args:"; val (cct, ist, (Const (\<^const_name>\<open>Let\<close>, _) $ e $ (Abs (id, T, b))))
  = (cct, (ist |> path_up_down [R, D] |> upd_env i |> set_or ORundef), body);

  (*case*) scan_dn1 cct (ist |> path_down [L, R]) e (*of*);
    (*======= end of scanning tacticals, a leaf =======*)
"~~~~~ fun scan_dn1 , args:"; val (((pt, p), ctxt, tac), (ist as {eval, or, ...}), t)
  = (cct, (ist |> path_down [L, R]), e);

val (Program.Tac _, NONE) = (*case*)
           check_leaf "locate" ctxt eval (get_subst ist) t (*of*);
"~~~~~ fun check_leaf , args:"; val (call, thy, prog_rls, (E, (a, v)), t)
  = ("locate", ctxt, eval, (get_subst ist), t);

    val (Program.Tac stac, a) = (*case*) Prog_Tac.eval_leaf E a v t (*of*);
"~~~~~ fun eval_leaf , args:"; val (E, _, _, (t as (Const (\<^const_name>\<open>SubProblem\<close>, _) $ _ $ _)))
  = (E, a, v, t);

     (Program.Tac (subst_atomic E t), NONE); (*return value*)
"~~~~~ from fun eval_leaf \<longrightarrow> fun check_leaf return val:"; val ((Program.Tac stac, a'))
  = ((Program.Tac (subst_atomic E t), NONE : term option));
        val stac' =
            Rewrite.eval_prog_expr ctxt prog_rls 
              (subst_atomic (Env.update_opt E (a,v)) stac);

    (Program.Tac stac', a'); (*return from check_leaf*) 
"~~~~~ from fun check_leaf \<longrightarrow> fun scan_dn1 return val:"; val  (Program.Tac prog_tac, form_arg)
  = (Program.Tac stac', a' : term option);

        (Program.Tac prog_tac, form_arg)  (*return from check_leaf*);

     check_tac1 cct ist (prog_tac, form_arg)  (*return from scan_dn1*);
"~~~~~ from fun scan_dn1\<longrightarrow>fun scan_up1 HOL.Let(*1*), return:"; val (Accept_Tac1 iss)
  = (check_tac1 cct ist (prog_tac, form_arg));

(*+*)val (pstate, ctxt, tac) = iss;
(*+*)if ContextC.is_empty ctxt then error "ERROR: scan_dn1 should NOT return ContextC.empty" else ();
"~~~~~ from fun scan_up1 HOL.Let(*1*), --------------------------------- NO return:"; val () = ();

(*+*)if ContextC.is_empty ctxt''''' then error "locate_input_tactic should NOT return ContextC.empty" else ();

"~~~~~ from fun locate_input_tactic \<longrightarrow>Step_Solve.by_tactic , return:"; val (LI.Safe_Step (istate, ctxt, tac))
  = (Safe_Step (Pstate ist''''', ctxt''''', tac'_'''''));
               val p' = next_in_prog po

               val (p'', _, _,pt') =
      Step.add tac (istate, ctxt) (pt, (p', p_));
"~~~~~ fun add , args:"; val (thy, (Tactic.Subproblem' ((domID, pblID, metID), oris, hdl, fmz_, ctxt_specify, f)),
      (l as (_, ctxt)), (pos as (p, p_)), pt)
  = (@{theory}(*ThyC.get_theory @{context} "Isac_Knowledge"*), tac, (istate, ctxt), (p', p_), pt);
	    val (pt, c) = cappend_problem pt p l (fmz_, (domID, pblID, metID))
	      (oris, (domID, pblID, metID), hdl, ctxt_specify);

(*+*)if ContextC.is_empty ctxt_specify then error "ERROR: Step.add should NOT get input ContextC.empty" else ();
(*+*)if (get_ctxt pt pos |> ContextC.is_empty) then error "Step.add MUST store ctxt"
(*+*)else ();
(*\\------------------ step into by_tactic Subproblem  -------------------------------------//*)
(*\------------------- step into me_Model_Problem_sub --------------------------------------//*)
val (p,_,f,nxt,_,pt) = return_me_Model_Problem_sub; val Model_Problem = nxt;

(* final test ... ----------------------------------------------------------------------------*)
if p = ([3], Pbl) andalso not (get_ctxt pt p |> ContextC.is_empty)
then () else error "Minisubpbl/300-init-subpbl.sml changed";

(*[3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p [] pt; val Add_Given "equality (- 1 + x = 0)" = nxt

